summaryrefslogtreecommitdiffstats
path: root/gis/eccodes
diff options
context:
space:
mode:
Diffstat (limited to 'gis/eccodes')
-rw-r--r--gis/eccodes/README21
-rw-r--r--gis/eccodes/eccodes.SlackBuild113
-rw-r--r--gis/eccodes/eccodes.info10
-rw-r--r--gis/eccodes/slack-desc19
4 files changed, 163 insertions, 0 deletions
diff --git a/gis/eccodes/README b/gis/eccodes/README
new file mode 100644
index 0000000000..b592d858eb
--- /dev/null
+++ b/gis/eccodes/README
@@ -0,0 +1,21 @@
+ecCodes is a package developed by ECMWF which provides an application
+programming interface and a set of tools for decoding and encoding
+messages in the following formats:
+
+ WMO FM-92 GRIB edition 1 and edition 2
+ WMO FM-94 BUFR edition 3 and edition 4
+ WMO GTS abbreviated header (only decoding).
+
+A useful set of command line tools provide quick access to the messages.
+C, Fortran 90 and Python interfaces provide access to the main ecCodes
+functionality.
+
+ecCodes is an evolution of GRIB-API. It is designed to provide the
+user with a simple set of functions to access data from several
+formats with a key/value approach.
+
+netcdf is an optional dependency and support will be compiled in if it
+is installed.
+
+NOTE: for 32bit platforms, the version is locked to 2.29.0 as 32 bit
+support was dropped in version 2.30.0 and above.
diff --git a/gis/eccodes/eccodes.SlackBuild b/gis/eccodes/eccodes.SlackBuild
new file mode 100644
index 0000000000..a1b6a4602c
--- /dev/null
+++ b/gis/eccodes/eccodes.SlackBuild
@@ -0,0 +1,113 @@
+#!/bin/bash
+
+# Slackware build script for eccodes
+
+# Copyright 2023-2024 Gregory J. L. Tourte <artourter@gmail.com>
+# All rights reserved.
+#
+# Redistribution and use of this script, with or without modification, is
+# permitted provided that the following conditions are met:
+#
+# 1. Redistributions of this script must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR "AS IS" AND ANY EXPRESS OR IMPLIED
+# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
+# EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
+# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
+# OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
+# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
+# OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
+# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+cd $(dirname $0) ; CWD=$(pwd)
+
+PRGNAM=eccodes
+VERSION=${VERSION:-2.35.0}
+BUILD=${BUILD:-1}
+TAG=${TAG:-_SBo}
+PKGTYPE=${PKGTYPE:-tgz}
+
+if [ -z "$ARCH" ]; then
+ case "$( uname -m )" in
+ i?86) ARCH=i586 ;;
+ arm*) ARCH=arm ;;
+ *) ARCH=$( uname -m ) ;;
+ esac
+fi
+
+if [ ! -z "${PRINT_PACKAGE_NAME}" ]; then
+ echo "$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.$PKGTYPE"
+ exit 0
+fi
+
+TMP=${TMP:-/tmp/SBo}
+PKG=$TMP/package-$PRGNAM
+OUTPUT=${OUTPUT:-/tmp}
+
+if [ "$ARCH" = "i586" ]; then
+ SLKCFLAGS="-O2 -march=i586 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "i686" ]; then
+ SLKCFLAGS="-O2 -march=i686 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "x86_64" ]; then
+ SLKCFLAGS="-O2 -fPIC"
+ LIBDIRSUFFIX="64"
+else
+ SLKCFLAGS="-O2"
+ LIBDIRSUFFIX=""
+fi
+
+set -e
+
+if [[ ${TESTBUILD:='NO'} == 'NO' ]]; then
+ TESTBUILDFLAGS='-DENABLE_TESTS=OFF'
+fi
+
+rm -rf $PKG
+mkdir -p $TMP $PKG $OUTPUT
+cd $TMP
+rm -rf $PRGNAM-$VERSION-Source
+tar xvf $CWD/$PRGNAM-$VERSION-Source.tar.gz
+cd $PRGNAM-$VERSION-Source
+chown -R root:root .
+find -L . \
+ -perm /111 -a \! -perm 755 -a -exec chmod 755 {} + -o \
+ \! -perm /111 -a \! -perm 644 -a -exec chmod 644 {} +
+
+mkdir -p build
+cd build
+ cmake \
+ -DCMAKE_C_FLAGS:STRING="$SLKCFLAGS" \
+ -DCMAKE_CXX_FLAGS:STRING="$SLKCFLAGS" \
+ -DCMAKE_INSTALL_PREFIX=/usr \
+ -Deccodes_FULL_INSTALL_LIB_DIR=/usr/lib${LIBDIRSUFFIX} \
+ -DENABLE_AEC=ON \
+ -DENABLE_PNG=ON \
+ -DENABLE_ECCODES_OMP_THREADS=ON \
+ $TESTBUILDFLAGS \
+ -DCMAKE_BUILD_TYPE=Release \
+ ..
+
+ make
+ [[ $TESTBUILD == "YES" ]] && make test
+ make install/strip DESTDIR=$PKG
+cd ..
+
+find $PKG -print0 | xargs -0 file | grep -e "executable" -e "shared object" | grep ELF \
+ | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null || true
+
+mkdir -p $PKG/usr/doc/$PRGNAM-$VERSION
+install -m 644 \
+ AUTHORS ChangeLog LICENSE NEWS NOTICE README.md \
+ $PKG/usr/doc/$PRGNAM-$VERSION
+cat $CWD/$PRGNAM.SlackBuild > $PKG/usr/doc/$PRGNAM-$VERSION/$PRGNAM.SlackBuild
+
+mkdir -p $PKG/install
+cat $CWD/slack-desc > $PKG/install/slack-desc
+
+cd $PKG
+/sbin/makepkg -l y -c n $OUTPUT/$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.$PKGTYPE
diff --git a/gis/eccodes/eccodes.info b/gis/eccodes/eccodes.info
new file mode 100644
index 0000000000..b3ad7fd648
--- /dev/null
+++ b/gis/eccodes/eccodes.info
@@ -0,0 +1,10 @@
+PRGNAM="eccodes"
+VERSION="2.35.0"
+HOMEPAGE="https://confluence.ecmwf.int/display/ECC"
+DOWNLOAD="UNSUPPORTED"
+MD5SUM=""
+DOWNLOAD_x86_64="https://confluence.ecmwf.int/download/attachments/45757960/eccodes-2.35.0-Source.tar.gz"
+MD5SUM_x86_64="39babf438f2e36641e78322ece62137a"
+REQUIRES="libaec"
+MAINTAINER="ArTourter"
+EMAIL="artourter@gmail.com"
diff --git a/gis/eccodes/slack-desc b/gis/eccodes/slack-desc
new file mode 100644
index 0000000000..b176003cbe
--- /dev/null
+++ b/gis/eccodes/slack-desc
@@ -0,0 +1,19 @@
+# HOW TO EDIT THIS FILE:
+# The "handy ruler" below makes it easier to edit a package description.
+# Line up the first '|' above the ':' following the base package name, and
+# the '|' on the right side marks the last column you can put a character in.
+# You must make exactly 11 lines for the formatting to be correct. It's also
+# customary to leave one space after the ':' except on otherwise blank lines.
+
+ |-----handy-ruler------------------------------------------------------|
+eccodes: eccodes (ECMWF encoding/decoding library for GRIB, BUFR and GTS)
+eccodes:
+eccodes: ecCodes is a package developed by ECMWF which provides an application
+eccodes: programming interface and a set of tools for decoding and encoding
+eccodes: messages WMO FM-92 GRIB edition 1 and edition 2, WMO FM-94 BUFR
+eccodes: edition 3 and edition 4, and WMO GTS abbreviated header (only
+eccodes: decoding).
+eccodes:
+eccodes: ecCodes is an evolution of GRIB-API. It is designed to provide the
+eccodes: user with a simple set of functions to access data from several
+eccodes: formats with a key/value approach.